import * as React from "react";
export interface IDropdownOption {
    id: number;
    name: string;
}
export interface IDropdownSelectProps extends React.Props<DropdownSelect> {
    value?: IDropdownOption;
    minimumLength?: number;
    placeholder?: string;
    options?: IDropdownOption[];
    remoteThrottle?: number;
    remoteQuery?: (query: string) => Promise<IDropdownOption[]>;
    hasGoButton?: boolean;
}
export interface IDropdownSelectState {
    filteredOptions?: IDropdownOption[];
    query?: string;
    open?: boolean;
    selectedValue?: IDropdownOption;
    selectedIndex?: number;
    remoteSearching?: boolean;
}
export declare class DropdownSelect extends React.Component<IDropdownSelectProps, IDropdownSelectState> {
    private id;
    private timer;
    constructor();
    filterRemote(query: string): void;
    filter(query: string): void;
    focusInput(): void;
    handleEvent(e: any): void;
    componentWillMount(): void;
    checkKey(e: any): boolean;
    constrainIndex(): void;
    buttonClick(): void;
    render(): JSX.Element;
}
